/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.wahlbeteiligung.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class WahlbeteiligungAuswertungExtendedDAO extends AbstractWahlbeteiligungAuswertungDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: TypAndStatusNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM WahlbeteiligungAuswertung o WHERE o.typ =?1 AND o.status = ?2 ORDER BY o.datum<br>
* SQL: <br>
*/
@Override
public java.util.List<WahlbeteiligungAuswertung> findByTypAndStatus( @javax.annotation.Nonnull de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungTyp typ,  @javax.annotation.Nonnull de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungStatus status) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlbeteiligungAuswertung.findByTypAndStatus" ,  typ ,  status  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByTypAndStatus(): Miss");
        }

        cache.put(key, super.findByTypAndStatus( typ ,  status  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByTypAndStatus(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<WahlbeteiligungAuswertung>) cache.lookup(key));
    }

    return super.findByTypAndStatus( typ ,  status  );
}
/**
* Name: WahlExistsNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT CASE WHEN (COUNT(o) > 0) THEN TRUE ELSE FALSE END FROM WahlbeteiligungAuswertung o WHERE o.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.lang.Boolean findByWahlExists( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlbeteiligungAuswertung.findByWahlExists" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlExists(): Miss");
        }

        cache.put(key, super.findByWahlExists( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlExists(): Hit");
      }

      return (java.lang.Boolean) cache.lookup(key);
    }

    return super.findByWahlExists( wahl  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM WahlbeteiligungAuswertung o WHERE o.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<WahlbeteiligungAuswertung> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("WahlbeteiligungAuswertung.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<WahlbeteiligungAuswertung>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
